diff -urN libgnomedb/libgnomedb/gnome-db-basic-form.c libgnomedbnew/libgnomedb/gnome-db-basic-form.c
--- libgnomedb/libgnomedb/gnome-db-basic-form.c	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/gnome-db-basic-form.c	2009-04-19 18:38:14.000000000 +0200
@@ -814,11 +1622,58 @@
 	}
 #endif
 
+	if (form->priv->scrolled_window != NULL) {
+
+		gtk_box_pack_start (GTK_BOX(form),
+				    (GtkWidget *) form->priv->scrolled_window,
+				    TRUE, TRUE, 0);
+
+		GSList *holders = form->priv->set->holders;
+		GSList *entries = form->priv->entries;
+		while (holders && entries) {
+			GdaHolder *holder = holders->data;
+			GnomeDbDataEntry *entry = entries->data;
+
+			const gchar *id = gda_holder_get_id (holder);
+
+			gpointer d[2];
+			d[0] = (gchar *) id;
+			d[1] = NULL;
+
+			gtk_container_foreach (GTK_CONTAINER(form->priv->scrolled_window),
+					       (GtkCallback) find_hbox, d);
+
+			GtkHBox *hbox = d[1];
+			g_print ("Hbox for: %s -- %p\n", id, hbox);
+
+			if (hbox != NULL) {
+				gboolean expand = gnome_db_data_entry_expand_in_layout
+					(GNOME_DB_DATA_ENTRY (entry));
+				form_expand = form_expand || expand;
+
+				gtk_box_pack_start (GTK_BOX(hbox), GTK_WIDGET(entry),
+						    expand, TRUE, 0);
+				gtk_widget_show (GTK_WIDGET(entry));
+
+				if (!g_object_get_data (G_OBJECT(hbox), "show_actions"))
+					gnome_db_data_entry_set_attributes
+						(GNOME_DB_DATA_ENTRY(entry),
+						 0, GDA_VALUE_ATTR_ACTIONS_SHOWN);
+			}
+
+			holders = g_slist_next (holders);
+			entries = g_slist_next (entries);
+		}
+
+		g_assert (holders == NULL && entries == NULL);
+		gtk_widget_show (GTK_WIDGET(form->priv->scrolled_window));
+	}
+
 	/* 
 	 * There is no layout spec (or the provided one could not be used),
 	 * so use the default tables arrangment
 	 */
-	if (!form->priv->layout_spec) {
+	if (!form->priv->layout_spec && form->priv->scrolled_window == NULL) {
 		GtkWidget *table, *label;
 
 		/* creating a table for all the entries */
@@ -878,10 +1733,10 @@
 				GtkWidget *evbox;
 				gboolean nullok = TRUE;
 				GSList *params;
-				GdaSetGroup *group;
+				GnomeDbSetGroup *group;
 
-				group = g_object_get_data (G_OBJECT (list->data), "group");
-				for (params = group->nodes; params; params = params->next) {
+				group = g_object_get_data (G_OBJECT (list->data), "__gnome_db_group");
+				for (params = group->group->nodes; params; params = params->next) {
 					if (nullok && gda_holder_get_not_null (GDA_SET_NODE (params->data)->holder))
 						nullok = FALSE;
 					if (!title)
@@ -890,7 +1745,7 @@
 				}
 				
 				if (!title) {
-					str = g_object_get_data (G_OBJECT (group->nodes_source->data_model), 
+					str = g_object_get_data (G_OBJECT (group->group->nodes_source->data_model), 
 								 "name");
 					if (str)
 						title = g_strdup (str);
@@ -913,7 +1768,7 @@
 				gtk_widget_show (label);
 				entry_label = evbox;
 				
-				title = g_object_get_data (G_OBJECT (group->nodes_source->data_model), "descr");
+				title = g_object_get_data (G_OBJECT (group->group->nodes_source->data_model), "descr");
 				if (title && *title)
 					gtk_tooltips_set_tip (form->priv->tooltips, evbox, title, NULL);
 			}
@@ -1044,15 +1899,14 @@
 	else { /* multiple parameters */
 		GSList *params;
 		GSList *values, *list;
-		GdaSetGroup *group;
+		GnomeDbSetGroup *group;
 
-		group = g_object_get_data (G_OBJECT (entry), "group");
-		params = group->nodes;
+		group = g_object_get_data (G_OBJECT (entry), "__gnome_db_group");
+		params = group->group->nodes;
 		values = gnome_db_entry_combo_get_values (GNOME_DB_ENTRY_COMBO (entry));
 		g_assert (g_slist_length (params) == g_slist_length (values));
 
-		list = values;
-		while (list) {
+		for (list = values; list; list = list->next, params = params->next) {
 			/* REM: if there is more than one value in 'params', then a 
 			 * signal is emitted for each param that is changed, 
 			 * and there is no way for the listener of that signal to know if it
@@ -1080,9 +1934,6 @@
 			else
 				TO_IMPLEMENT;
 			form->priv->forward_param_updates = TRUE;
-
-			list = g_slist_next (list);
-			params = g_slist_next (params);
 		}
 		g_slist_free (values);
 
@@ -1127,7 +1978,7 @@
 parameter_changed_cb (GdaHolder *param, GnomeDbDataEntry *entry)
 {
 	GnomeDbBasicForm *form = g_object_get_data (G_OBJECT (entry), "form");
-	GdaSetGroup *group = g_object_get_data (G_OBJECT (entry), "group");
+	GnomeDbSetGroup *group = g_object_get_data (G_OBJECT (entry), "__gnome_db_group");
 	const GValue *value = gda_holder_get_value (param);
 
 	if (form->priv->forward_param_updates) {
@@ -1150,7 +2001,7 @@
 		}
 		if (group) {
 			GSList *values = NULL;
-			GSList *list = group->nodes;
+			GSList *list = group->group->nodes;
 			gboolean allnull = TRUE;
 
 			while (list) {
@@ -1228,14 +2079,14 @@
 	g_return_if_fail (form->priv);
 
 	for (list = form->priv->entries; list; list = list->next) {
-		GdaSetGroup *group;
+		GnomeDbSetGroup *group;
 
-		group = g_object_get_data (G_OBJECT (list->data), "group");
+		group = g_object_get_data (G_OBJECT (list->data), "__gnome_db_group");
 
 		if (group) {
 			/* Combo entry */
 			GSList *values = NULL;
-			GSList *params = group->nodes;
+			GSList *params = group->group->nodes;
 			gboolean allnull = TRUE;
 			
 			while (params) {
@@ -1601,10 +2452,10 @@
 		else {
 			/* multiple parameters */
 			GSList *params;
-			GdaSetGroup *group;
+			GnomeDbSetGroup *group;
 
-			group = g_object_get_data (G_OBJECT (entries->data), "group");
-			for (params = group->nodes; params; params = params->next) {
+			group = g_object_get_data (G_OBJECT (entries->data), "__gnome_db_group");
+			for (params = group->group->nodes; params; params = params->next) {
 				if (GDA_SET_NODE (params->data)->holder == (gpointer) param) {
 					entry = GTK_WIDGET (entries->data);
 					break;
diff -urN libgnomedb/libgnomedb/gnome-db-data-widget.c libgnomedbnew/libgnomedb/gnome-db-data-widget.c
--- libgnomedb/libgnomedb/gnome-db-data-widget.c	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/gnome-db-data-widget.c	2009-04-19 18:38:14.000000000 +0200
@@ -373,3 +373,19 @@
 	else 
 		return GNOME_DB_DATA_WIDGET_WRITE_ON_DEMAND;
 }
+
+/**
+ * gnome_db_data_widget_set_data_layout
+ * @iface: an object which implements the #GnomeDbDataWidget interface
+ * @string: xml string
+ *
+ * Sets a data layout according an XML string in the @iface widget .
+ */
+void 
+gnome_db_data_widget_set_data_layout (GnomeDbDataWidget *iface, const gpointer data)
+{
+	g_return_if_fail (GNOME_DB_IS_DATA_WIDGET (iface));
+
+	if (GNOME_DB_DATA_WIDGET_GET_IFACE (iface)->set_data_layout)
+		(GNOME_DB_DATA_WIDGET_GET_IFACE (iface)->set_data_layout) (iface, data);	
+}
diff -urN libgnomedb/libgnomedb/gnome-db-data-widget.h libgnomedbnew/libgnomedb/gnome-db-data-widget.h
--- libgnomedb/libgnomedb/gnome-db-data-widget.h	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/gnome-db-data-widget.h	2009-04-19 18:38:14.000000000 +0200
@@ -59,6 +59,7 @@
 	void                 (* set_gda_model)       (GnomeDbDataWidget *iface, GdaDataModel *model);
 	gboolean             (* set_write_mode)      (GnomeDbDataWidget *iface, GnomeDbDataWidgetWriteMode mode);
 	GnomeDbDataWidgetWriteMode (* get_write_mode)(GnomeDbDataWidget *iface);
+	void                 (* set_data_layout)     (GnomeDbDataWidget *iface, const gpointer data);
 
 	/* signals */
 	void                 (* proxy_changed)       (GnomeDbDataWidget *iface, GdaDataProxy *proxy);
@@ -84,6 +85,8 @@
 gboolean          gnome_db_data_widget_set_write_mode            (GnomeDbDataWidget *iface, GnomeDbDataWidgetWriteMode mode);
 GnomeDbDataWidgetWriteMode gnome_db_data_widget_get_write_mode   (GnomeDbDataWidget *iface);
 
+void              gnome_db_data_widget_set_data_layout           (GnomeDbDataWidget *iface, const gpointer data);
+
 G_END_DECLS
 
 #endif
diff -urN libgnomedb/libgnomedb/gnome-db-raw-form.c libgnomedbnew/libgnomedb/gnome-db-raw-form.c
--- libgnomedb/libgnomedb/gnome-db-raw-form.c	2008-12-30 11:22:49.000000000 +0100
+++ libgnomedbnew/libgnomedb/gnome-db-raw-form.c	2009-04-19 18:38:14.000000000 +0200
@@ -62,6 +62,7 @@
 static void            gnome_db_raw_form_widget_set_gda_model (GnomeDbDataWidget *iface, GdaDataModel *model);
 static gboolean        gnome_db_raw_form_widget_set_write_mode (GnomeDbDataWidget *iface, GnomeDbDataWidgetWriteMode mode);
 static GnomeDbDataWidgetWriteMode gnome_db_raw_form_widget_get_write_mode (GnomeDbDataWidget *iface);
+static void gnome_db_raw_form_set_data_layout (GnomeDbDataWidget  *iface, gpointer  data);
 
 struct _GnomeDbRawFormPriv
 {
@@ -134,6 +135,7 @@
 	iface->set_gda_model = gnome_db_raw_form_widget_set_gda_model;
 	iface->set_write_mode = gnome_db_raw_form_widget_set_write_mode;
 	iface->get_write_mode = gnome_db_raw_form_widget_get_write_mode;
+	iface->set_data_layout = gnome_db_raw_form_set_data_layout;
 }
 
 static void
@@ -1022,3 +1024,15 @@
 
 	return form->priv->write_mode;
 }
+
+static void
+gnome_db_raw_form_set_data_layout (GnomeDbDataWidget  *iface, gpointer  data)
+{
+	GnomeDbRawForm *raw_form;
+	
+	g_return_if_fail (GNOME_DB_IS_RAW_FORM (iface));
+	raw_form = GNOME_DB_RAW_FORM (iface);
+	g_return_if_fail (raw_form->priv);
+
+	g_object_set (G_OBJECT (raw_form), "data_layout", data, NULL);
+}
